/*
http://emberjs.com/documentation/#handlebars
(Ember determines whether a path is global or relative to the view by checking whether the first letter is capitalized, which is why your Ember.Application instance should start with a capital letter.)

what's the point of window.App?

*/

App = Em.Application.create();

/**************************
* Models
**************************/
App.Tweet = Em.Object.extend({
	avatar: null,
	screen_name: null,
	text: null,
	date: null
});

/**************************
* Views
**************************/
App.TFView = Em.TextField.extend({
	insertNewline: function(){
		App.tweetsArray.loadTweets();
	}
});

/**************************
* Controllers
**************************/
App.tweetsArray = Em.ArrayController.create({
	content: [],
	username: '',
	loadTweets: function() {

		// scope it
		var me = this;
		var username = me.get("username");

		// does username property have a value?
		if ( username ) {

			// mention use of .fmt() function
			// http://code418.com/blog/2012/03/08/useful-emberjs-functions/
			var url = 'http://api.twitter.com/1/statuses/user_timeline.json'
				url += '?screen_name=%@&callback=?'.fmt(me.get("username"));

			// push username to recent user array
			App.recentUsersArray.addUser( username );

			// go get the data tiger!
			$.getJSON(url,function(data){

				// truncates existing array data so that UI shows new information at top 
				me.set('content', []);

				$(data).each(function(index,value){

					// create new instance of the Tweet model
					var t = App.Tweet.create({
						avatar: value.user.profile_image_url,
						screen_name: value.user.screen_name,
						text: value.text,
						date: value.created_at
					});
					
					// push into the content array
					me.pushObject(t);
				})
			});

		}

	}
});

App.recentUsersArray = Em.ArrayController.create({
	content: [],
	addUser: function(name) {
		if ( this.contains(name) ) this.removeObject(name);
		this.pushObject(name);
	},
	reverse: function(){
		return this.toArray().reverse();
	}.property('@each'),
	searchAgain: function(view){
		App.tweetsArray.set('username', view.context);
		App.tweetsArray.loadTweets();
	},
	removeUser: function(view){
		this.removeObject(view.context);
	}
});